from flask import Flask, request, render_template, redirect, url_for, send_from_directory
from werkzeug.utils import secure_filename
import os
from data_processing import *

ALLOWED_TYPE = set(['csv'])
def allowed_file(filename):
    return '.' in filename and \
        filename.rsplit('.',1)[1].lower() in ALLOWED_TYPE




app = Flask(__name__)

if __name__ == "__main__":
    app.run(host='0.0.0.0')
    
@app.route('/')
def home():
    return render_template('index.html')


@app.route('/upload', methods = ['GET', 'POST'])
def upload():
    if request.method == 'POST':
        file = request.files['file']
        if file and allowed_file(file.filename):
            filename = secure_filename(file.filename)
            file.save(os.path.join('input', filename))

        return render_template('index.html')
    return render_template('upload.html')

@app.route('/download')
def download():
    return render_template('download.html', files = os.listdir('input'))


@app.route('/download/<filename>')
def download_file(filename):
    return send_from_directory('input', filename)

@app.route('/map_production', methods = ['GET'])
def map_production():
    a = process_data(filename= "/home/soul/Desktop/web/input/masterTest.csv")
    return render_template('index.html')