
import json
import datetime as dt
import geopy.distance as gd
import pandas as pd
import math


def process_data(filename):
    raw = pd.read_csv(filename, skiprows=1, header=None)
    raw = raw.drop_duplicates().values.tolist()
    
    cleaned = {}
    for item in raw:
        if item[0] in cleaned:
            cleaned[item[0]].append(item)
        else:
            cleaned[item[0]] = item


    for drifter in cleaned:
        try:
            previous = [(cleaned[drifter][7][4], cleaned[drifter][7][3]), getDatetime(cleaned[drifter][7])]
        except (ValueError, IndexError) as e:
            pass
        
        for rec in cleaned[drifter][8:]:
            try:
                longlatRec = (rec[4], rec[3])

                
                dateRec = getDatetime(rec)
                
                timediff = (dateRec-previous[1]).total_seconds() 
                distance = gd.distance(previous[0],longlatRec).m
                speed = 0
                speed = round(distance/timediff,3)
                rec.append(speed)
                previous = [longlatRec, dateRec]

            except (ZeroDivisionError, ValueError) as e:
                pass 

    rDict = {}
    for key in cleaned:
        rDict[key] = []
        for records in cleaned[key][7:]:
            temp = records[1:]
            for i in range(len(temp)):
                try:
                    if math.isnan(temp[i]):
                        temp[i] = 0
                except TypeError:
                    pass
            if 100 < temp[2] < 140 and temp[3] != 0:
                rDict[records[0]].append(tuple(temp))
            else:
                pass

    app_json = json.dumps(rDict)

    with open("Json_processed/processedData.json", "w") as outfile:
        outfile.write(app_json)

    print(rDict["Master"][:15])
    return app_json

def getDatetime(data):
    a = dt.datetime(int(data[1].split('-')[0]), int(data[1].split('-')[1]), int(data[1].split('-')[2]), int(data[2].split(':')[0]), int(data[2].split(':')[1]), int(data[2].split(':')[2]))
    return a

process_data("/home/soul/Desktop/web/input/masterTest.csv")
#a = process_data("/home/soul/Desktop/web/input/masterTest.csv")
#print(type(a))
